using Windows.Storage;

using Microsoft.UI.Xaml;
using Microsoft.UI.Xaml.Controls;

namespace TestProject;

/// <summary>
/// ׸ Ž øƮ 
/// </summary>
public class ExplorerItemTemplateSelector : DataTemplateSelector
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region Ʈ øƮ - DefaultTemplate

    /// <summary>
    /// Ʈ øƮ
    /// </summary>
    public DataTemplate DefaultTemplate { get; set; }

    #endregion
    #region  ׸ øƮ - MusicItemTemplate

    /// <summary>
    ///  ׸ øƮ
    /// </summary>
    public DataTemplate MusicItemTemplate { get; set; }

    #endregion
    #region ׸ ׸ øƮ - PictureItemTemplate

    /// <summary>
    /// ׸ ׸ øƮ
    /// </summary>
    public DataTemplate PictureItemTemplate { get; set; }

    #endregion
    #region   øƮ - MusicFolderTemplate

    /// <summary>
    ///   øƮ
    /// </summary>
    public DataTemplate MusicFolderTemplate { get; set; }

    #endregion
    #region ׸  øƮ - PictureFolderTemplate

    /// <summary>
    /// ׸  øƮ
    /// </summary>
    public DataTemplate PictureFolderTemplate { get; set; }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Protected

    #region øƮ ϱ (ھ) - SelectTemplateCore(item)

    /// <summary>
    /// øƮ ϱ (ھ)
    /// </summary>
    /// <param name="item">׸</param>
    /// <returns> øƮ</returns>
    protected override DataTemplate SelectTemplateCore(object item)
    {
        TreeViewNode treeViewNode = item as TreeViewNode;

        if(treeViewNode.Content is StorageFolder)
        {
            StorageFolder storageFolder = treeViewNode.Content as StorageFolder;

            if(storageFolder.DisplayName.StartsWith("Pictures"))
            {
                return PictureFolderTemplate;
            }

            if(storageFolder.DisplayName.StartsWith("Music"))
            {
                return MusicFolderTemplate;
            }
        }
        else if(treeViewNode.Content is StorageFile)
        {
            StorageFile storageFile = treeViewNode.Content as StorageFile;

            if(storageFile.ContentType.StartsWith("image"))
            {
                return PictureItemTemplate;
            }

            if(storageFile.ContentType.StartsWith("audio"))
            {
                return MusicItemTemplate;
            }
        }

        return DefaultTemplate;
    }

    #endregion
}